unit UnidadCopiaSeguridad;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, FileCtrl, ComCtrls, ExtCtrls, VCLUnZip,
  VCLZip;

type
  TformCopiaSeguridad = class(TForm)
    gContrasena: TGroupBox;
    Label1: TLabel;
    txtContrasena: TEdit;
    gProgreso: TGroupBox;
    lPF: TLabel;
    LPT: TLabel;
    bp: TProgressBar;
    bpT: TProgressBar;
    lFicheros: TFileListBox;
    BCopia: TBitBtn;
    BCancelar: TBitBtn;
    gDestino: TGroupBox;
    txtDestino: TEdit;
    Label2: TLabel;
    BitBtn2: TBitBtn;
    Panel1: TPanel;
    zComp: TVCLZip;
    dlGuardar: TSaveDialog;
    GroupBox1: TGroupBox;
    opDisquetes: TCheckBox;
    procedure BCopiaClick(Sender: TObject);
    procedure zCompFilePercentDone(Sender: TObject; Percent: Integer);
    procedure zCompGetNextDisk(Sender: TObject; NextDisk: Integer;
  var FName: String);
    procedure zCompPromptForOverwrite(Sender: TObject;
  var OverWriteIt: Boolean; FileIndex: Integer; var FName: String);
    procedure zCompTotalPercentDone(Sender: TObject; Percent: Integer);
    procedure zCompZipComplete(Sender: TObject; FileCount: Integer);
    procedure BitBtn2Click(Sender: TObject);
    procedure BCancelarClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
  public
    rutaCopia : string;
    { Public declarations }
  end;

var
  formCopiaSeguridad: TformCopiaSeguridad;

implementation

uses UnidadProcedimientos;

{$R *.dfm}

procedure TformCopiaSeguridad.BCopiaClick(Sender: TObject);
var
  i : integer;
//  Disponible, Total, Libre: Int64;
//  uni : string;
begin
  bp.Min := 0;
  bp.Max := 100;
  bpT.Min := 0;
  bpT.Max := 100;
  zcomp.ZipName := txtdestino.Text;
  lFicheros.Directory := rutaCopia;
  lFicheros.Update;
  if txtContrasena.Text <> '' then
    zcomp.Password := txtContrasena.Text;
{  uni := tipoUnidad (ExtractFileDrive(txtdestino.Text));
  if ( uni = 'CD-ROM') or (uni = 'Disco RAM') or (uni = 'No es una unidad') then
    MessageDlg('No se puede escribir en la ruta seleccionada. Compruebe ' +
        'la ruta de destino y vuelva a intentarlo.', mtError, [mbok],0)
  else
  begin
    if uni = 'Removible' then
    begin
      GetDiskFreeSpaceEx(PChar(extractfiledrive(txtdestino.Text)), Disponible, Total, @Libre);
      if total <= 1457664 then //es un disquete, comprobaremos su espacio libre
      begin
//        if disponible < 1457664 then
//        begin
//          MessageDlg('El disco introducido no est vaco. Es posible que necesite que est vaco.', mtWarning, [mbok],0);
//        end
//        else
        zComp.MultiMode := mmSpan  //disquetes
      end
      else
        zComp.MultiMode := mmNone; //No disquetes
    end
    else
      zComp.MultiMode := mmNone; //No disquetes}
    if opDisquetes.Checked then
      zComp.MultiMode := mmSpan  //disquetes
    else
      zComp.MultiMode := mmNone; //No disquetes
    lFicheros.SelectAll;
    for i := 0 to lFicheros.Count - 1 do
    begin
      lFicheros.ItemIndex := i;
      zcomp.FilesList.Add (lFicheros.FileName);
    end;
    zComp.FilesList.Add(ExtractFilePath(Application.ExeName) + 'VentasIngresos.ini');
    zComp.FilesList.Add(ExtractFilePath(Application.ExeName) + 'Descripcion.txt');
    zComp.ZipName := txtDestino.Text;
    gContrasena.Visible := false;
    gDestino.Visible := false;
    gProgreso.Visible := true;
    zcomp.Zip;
//  end;
end;

procedure TformCopiaSeguridad.zCompFilePercentDone(Sender: TObject; Percent: Integer);
begin
  bp.Position := Percent;
  bp.Refresh;
  lPF.Caption := 'Progreso fichero actual...' + inttostr(percent);
  lpf.Refresh;
end;

procedure TformCopiaSeguridad.zCompGetNextDisk(Sender: TObject; NextDisk: Integer;
  var FName: String);
begin
  showmessage ('Introduzca el disco n ' + inttostr(nextdisk));
end;

procedure TformCopiaSeguridad.zCompPromptForOverwrite(Sender: TObject;
  var OverWriteIt: Boolean; FileIndex: Integer; var FName: String);
begin
  ShowMessage('Se va a reemplazar el archivo: ' + fname);
end;

procedure TformCopiaSeguridad.zCompTotalPercentDone(Sender: TObject; Percent: Integer);
begin
  bpT.Position := Percent;
  bpT.Refresh;
  LPT.Caption := 'Progreso todos...' + inttostr(percent);
  LPT.Refresh;
end;


procedure TformCopiaSeguridad.zCompZipComplete(Sender: TObject; FileCount: Integer);
begin
  esCadINI('Copia de seguridad','Ruta', ExtractFilePath(txtdestino.text));
  esCadINI('Copia de seguridad','Nombre fichero',extractfilename(txtDestino.Text));
  esCadINI('Copia de seguridad','Ruta y Nombre fichero', txtDestino.Text);  
  esFechaINI('Copia de seguridad','Fecha',date);
  esFechaINI('Copia de seguridad','Hora',time);
  MessageDlg ('La copia de seguridad ha finalizado correctamente. Nmero ' +
      'de ficheros comprimidos: ' + inttostr(filecount), mtInformation, [mbok],0);
  close;    
end;

procedure TformCopiaSeguridad.BitBtn2Click(Sender: TObject);
begin
  dlguardar.Filter := 'Ficheros Zip (*.zip)|*.zip|Todos los ficheros|*.*';
  dlGuardar.DefaultExt := 'zip';
  dlGuardar.InitialDir := leCadINI('Copia de seguridad','Ruta',ParamStr(0));
  dlguardar.Title := 'Copia de seguridad...';
  dlguardar.FileName := leCadINI('Copia de seguridad',
      'Nombre fichero', 'Copia de seguridad');
  if dlGuardar.execute then
  begin
    txtDestino.Text := dlGuardar.FileName;
  end;
end;

procedure TformCopiaSeguridad.BCancelarClick(Sender: TObject);
begin
  close;
end;

procedure TformCopiaSeguridad.FormShow(Sender: TObject);
begin
  txtDestino.Text := leCadINI('Copia de seguridad',
      'Ruta y Nombre fichero', 'C:\CopiaSeguridad.zip');  
end;

end.
