unit UnidadImprimir;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, QuickRpt, QRCtrls, ExtCtrls;

type
  TformImprimir = class(TForm)
    BVistaPrevia: TBitBtn;
    BImprimir: TBitBtn;
    BCancelar: TBitBtn;
    GroupBox1: TGroupBox;
    opTodas: TRadioButton;
    opActual: TRadioButton;
    LImpresionNotasCorta: TQuickRep;
    BTitulo: TQRBand;
    QRLabel12: TQRLabel;
    QRDBText8: TQRDBText;
    QRDBText9: TQRDBText;
    lNumeroFacturaNotasCorta: TQRLabel;
    QRLabel16: TQRLabel;
    QRLabel17: TQRLabel;
    LNombreClienteC: TQRLabel;
    LDireccionClienteC: TQRLabel;
    QRLabel20: TQRLabel;
    QRLabel21: TQRLabel;
    QRLabel22: TQRLabel;
    QRLabel23: TQRLabel;
    LLogotipoCorto: TQRImage;
    QRBand5: TQRBand;
    QRShape5: TQRShape;
    QRShape7: TQRShape;
    LTipoL2: TQRLabel;
    BSub: TQRSubDetail;
    QRDBText10: TQRDBText;
    QRDBText16: TQRDBText;
    QRDBText17: TQRDBText;
    QRDBText18: TQRDBText;
    LimpresionNotasLarga: TQuickRep;
    QRBand1: TQRBand;
    QRLabel13: TQRLabel;
    QRDBText6: TQRDBText;
    QRDBText7: TQRDBText;
    LNumFac: TQRLabel;
    QRLabel5: TQRLabel;
    QRLabel6: TQRLabel;
    LNombreCliente: TQRLabel;
    LDireccionCliente: TQRLabel;
    QRLabel7: TQRLabel;
    QRLabel8: TQRLabel;
    QRLabel9: TQRLabel;
    QRLabel10: TQRLabel;
    LLogotipoLargo: TQRImage;
    QRBand2: TQRBand;
    QRShape4: TQRShape;
    QRShape9: TQRShape;
    LTipoL: TQRLabel;
    QRSubDetail1: TQRSubDetail;
    QRDBText11: TQRDBText;
    QRDBText12: TQRDBText;
    QRDBText13: TQRDBText;
    QRDBText14: TQRDBText;
    QRBand3: TQRBand;
    QRLabel11: TQRLabel;
    QRDBText15: TQRDBText;
    QRShape8: TQRShape;
    LTotal: TQRLabel;
    LImporte: TQRDBText;
    LLinea: TQRShape;
    LImpresionDiario: TQuickRep;
    DetailBand1: TQRBand;
    LNombre: TQRLabel;
    LProfesion: TQRLabel;
    LNIF: TQRLabel;
    LClienteNombre: TQRLabel;
    LClienteDomicilio: TQRLabel;
    LClientePoblacion: TQRLabel;
    LClienteProvincia: TQRLabel;
    LClienteCIF: TQRLabel;
    QRLabel1: TQRLabel;
    QRDBText1: TQRDBText;
    QRDBText2: TQRDBText;
    lFacturaNumero: TQRLabel;
    QRShape1: TQRShape;
    lEuros: TQRLabel;
    LDescripcion: TQRMemo;
    QRDBText3: TQRDBText;
    LPorcentajeIVA: TQRLabel;
    QRDBText4: TQRDBText;
    QRShape2: TQRShape;
    QRDBText5: TQRDBText;
    lEtiquetaTotal: TQRLabel;
    QRShape3: TQRShape;
    LCalle: TQRLabel;
    LCPPoblacion: TQRLabel;
    LTelefono: TQRLabel;
    gEtiqueta: TGroupBox;
    txtEtiqueta: TEdit;
    Label1: TLabel;
    lCIFLbC: TQRLabel;
    lCIFClienteC: TQRLabel;
    lCIFLbL: TQRLabel;
    lCIFClienteL: TQRLabel;
    procedure FormShow(Sender: TObject);
    procedure BCancelarClick(Sender: TObject);
    procedure BVistaPreviaClick(Sender: TObject);
    procedure QRBand1BeforePrint(Sender: TQRCustomBand;
      var PrintBand: Boolean);
    procedure BTituloBeforePrint(Sender: TQRCustomBand;
      var PrintBand: Boolean);
    procedure opTodasClick(Sender: TObject);
    procedure opActualClick(Sender: TObject);

    procedure confImpresion (imprimir : boolean);
    procedure imprimirFactura (imprimirF : boolean);
    procedure imprimirDiario (imprimirF : boolean);

    procedure BImprimirClick(Sender: TObject);
    procedure DetailBand1BeforePrint(Sender: TQRCustomBand;
      var PrintBand: Boolean);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  formImprimir: TformImprimir;

implementation

uses UnidadMenuPrincipal, UnidadModuloDatos, UnidadProcedimientos, DB;

{$R *.dfm}

procedure TFormImprimir.confImpresion (imprimir : boolean);
begin
  try
    //tipo de listado
    if mdDatos.TFacturasPresupuesto.Value = true then //Presupuesto
    begin
      LTipoL.Caption := txtEtiqueta.Text;
      LNumFac.Caption := 'N Presupuesto:';
      if FileExists(leCadINI('Logotipo', 'Ruta y nombre', '')) then
      begin
        LLogotipoLargo.Stretch := leBoolINI('Logotipo', 'Estrechar', true);
        LLogotipoLargo.AutoSize := leBoolINI('Logotipo', 'Tamao automtico', false);
        try
          LLogotipoLargo.Picture.LoadFromFile(leCadINI('Logotipo', 'Ruta y nombre', ''));
        except
          on E: Exception do
            MessageDlg('Se ha producido el siguiente error al intentar cargar el logotipo: ' +
                chr(13) + chr(13) + e.message, mterror, [mbok],0)
        end;
      end;
      if imprimir then
        LImpresionNotasLarga.Print
      else
        LimpresionNotasLarga.Preview;
    end
    else
    begin
      if mdDatos.TFacturasCorta.Value = true then
      begin
        LTipoL.Caption := txtEtiqueta.Text;
        lNumeroFacturaNotasCorta.Caption :=
            leCadINI('Configuracin', 'Etiqueta - N Factura', 'Factura n:');

        if FileExists(leCadINI('Logotipo', 'Ruta y nombre', '')) then
        begin
          LLogotipoCorto.Stretch := leBoolINI('Logotipo', 'Estrechar', true);
          LLogotipoCorto.AutoSize := leBoolINI('Logotipo', 'Tamao automtico', false);
          try
            LLogotipoCorto.Picture.LoadFromFile(leCadINI('Logotipo', 'Ruta y nombre', ''));
          except
            on E: Exception do
              MessageDlg('Se ha producido el siguiente error al intentar cargar el logotipo: ' +
                  chr(13) + chr(13) + e.message, mterror, [mbok],0)
          end;
        end;
        if imprimir then
          LimpresionNotasCorta.Print
        else
          LimpresionNotasCorta.Preview;
      end
      else
      begin
        LTipoL.Caption := txtEtiqueta.Text;
        LNumFac.Caption :=
            leCadINI('Configuracin', 'Etiqueta - N Factura', 'Factura n:');
        if FileExists(leCadINI('Logotipo', 'Ruta y nombre', '')) then
        begin
          LLogotipoLargo.Stretch := leBoolINI('Logotipo', 'Estrechar', true);
          LLogotipoLargo.AutoSize := leBoolINI('Logotipo', 'Tamao automtico', false);
          try
            LLogotipoLargo.Picture.LoadFromFile(leCadINI('Logotipo', 'Ruta y nombre', ''));
          except
            on E: Exception do
              MessageDlg('Se ha producido el siguiente error al intentar cargar el logotipo: ' +
                  chr(13) + chr(13) + e.message, mterror, [mbok],0)
          end;
        end;
        if imprimir then
          LimpresionNotasLarga.Print
        else
          LimpresionNotasLarga.Preview;
      end;
    end;
  except
    on E: Exception do
      MessageDlg('Se ha producido el siguiente error al intentar cargar el logotipo: ' +
          chr(13) + chr(13) + e.message, mterror, [mbok],0)
  end;
end;

procedure TFormImprimir.imprimirFactura (imprimirF : boolean);
var
  lugar : integer;
begin
  if mdDatos.TFacturas.RecordCount <= 0 then
    MessageDlg('No hay datos para imprimir segn el filtro actual.',
        mtInformation, [mbok],0)
  else
  begin
    lugar := mdDatos.TFacturas.RecNo;
//    mdDatos.TFacturas.DisableControls;
    if opActual.Checked then  //filtrar slo actual
    begin
      mdDatos.TFacturas.Filter := '[Numero] = ' +
          inttostr(mdDatos.TFacturasNumero.value);
      mddatos.tfacturas.filtered := true;
      confImpresion (imprimirF);
    end;
    if opTodas.Checked then  //todas (segn el filtro actual)
    begin
      mdDatos.TFacturas.Filter := formMenuPrincipal.TablaFacturas.Filter.FilterText;
      mddatos.TFacturas.Filtered := true;
      if MessageDlg('Se van a imprimir: ' +
          inttostr(mddatos.TFacturas.recordcount) + ' facturas/presupuestos.'
          + ' Desea continuar?', mtConfirmation, [mbyes, mbno],0) = mrno then
        exit;  //salir si pulsa NO
      mddatos.TFacturas.First;
      while not mdDatos.TFacturas.Eof do
      begin
        confImpresion (imprimirF);
        mddatos.TFacturas.next;
      end;
    end;
    mdDatos.TFacturas.Filter := '';
    mddatos.tfacturas.filtered := false;
    mddatos.TFacturas.EnableControls;
    mdDatos.TFacturas.RecNo := lugar;
  end;
end;


procedure TFormImprimir.imprimirDiario (imprimirF : boolean);
begin
  LPorcentajeIVA.Caption := leCadINI('Configuracin', 'Etiqueta - IVA', 'I.V.A. 16 %');
  lEuros.Caption := leCadINI('Configuracin', 'Etiqueta - Euros', 'EUROS');
  lEtiquetaTotal.Caption := leCadINI('Configuracin', 'Etiqueta - Total', '');
  LNombre.Caption := leCadINI('Empresa', 'Nombre', '');
  LProfesion.Caption := leCadINI('Empresa', 'Profesion', '');
  LNIF.Caption := leCadINI('Empresa', 'NIF', '');
  lFacturaNumero.Caption := leCadINI('Configuracin', 'Etiqueta - N Factura', 'Factura n:');

  LTelefono.Caption := leCadINI('Empresa', 'Telefono', '');
  LCalle.Caption := leCadINI('Empresa', 'Calle', '');
  LCPPoblacion.Caption := leCadINI('Empresa', 'CP', '') +
      ' ' + leCadINI('Empresa', 'Poblacion', '') + ' (' +
      leCadINI('Empresa', 'Provincia', '') + ')';
  mddatos.TC4.Close;
  mddatos.TC4.sql.clear;
  mddatos.TC4.databasename := mdDatos.ruta;
  mddatos.TC4.SQL.Add('SELECT *');
  mddatos.TC4.SQL.Add('FROM Diario');
  mddatos.TC4.SQL.Add('ORDER BY NORDEN');
  if opTodas.Checked then  //imprimir todos
  begin
    mddatos.TC4.Filter := formmenuprincipal.TablaDiario.Filter.FilterText;
    mdDatos.TC4.Filtered := True;
    mddatos.TC4.Open;
    if mddatos.TC4.RecordCount > 0 then
      LImpresionDiario.Preview
    else
      MessageDlg('No hay datos para imprimir segn el filtro actual.',
          mtInformation, [mbok],0);
  end
  else //imprimir actual
  begin
    mdDatos.TC4.Filter := '[NOrden] = ' + floattostr(mdDatos.TDiarioNORDEN.value);
    mdDatos.TC4.Filtered := True;
    mddatos.TC4.Open;
    if mddatos.TC4.RecordCount > 0 then
      LImpresionDiario.Preview
    else
      MessageDlg('No hay datos para imprimir segn el filtro actual.',
          mtInformation, [mbok],0);
  end;
end;


procedure TformImprimir.FormShow(Sender: TObject);
var
  cortas, largas : boolean;
begin
  case formmenuprincipal.tag of
    0 : begin //facturas, presupuestos
      if mdDatos.TFacturasPresupuesto.AsBoolean = true then
      begin
        txtEtiqueta.Text := leCadINI('Configuracin', 'Etiqueta - Presupuestos - Ttulo', 'PRESUPUESTO');
        LimpresionNotasLarga.Page.TopMargin := leEntINI('Configuracin', 'Etiqueta - Presupuestos - Margen - Largo', 10);
        //LImpresionNotasCorta.Page.TopMargin := leEntINI('Configuracin', 'Etiqueta - Presupuestos - Margen - Corto', 10);
      end
      else
      begin
        txtEtiqueta.Text := leCadINI('Configuracin', 'Etiqueta - Facturas - Ttulo', 'FACTURA');
        LimpresionNotasLarga.Page.TopMargin := leEntINI('Configuracin', 'Etiqueta - Facturas - Margen - Largo', 10);
        LImpresionNotasCorta.Page.TopMargin := leEntINI('Configuracin', 'Etiqueta - Facturas - Margen - Corto', 10);
      end;

      gEtiqueta.Visible := true;
      caption := 'Impresin de Facturas...';
      mddatos.TC3.Close;
      mddatos.tc3.DatabaseName := mdDatos.ruta;
      mddatos.TC3.SQL.Clear;
      mddatos.tc3.SQL.Add('SELECT * FROM Facturas WHERE Corta = True');
      mddatos.tc3.Filter := formMenuPrincipal.TablaFacturas.Filter.FilterText;
      mddatos.TC3.Filtered := true;
      mddatos.TC3.open;
      cortas := mddatos.tc3.RecordCount > 0;
      mddatos.TC3.Close;
      mddatos.TC3.SQL.Clear;
      mddatos.tc3.SQL.Add('SELECT * FROM Facturas WHERE Corta = False');
      mddatos.tc3.Filter := formMenuPrincipal.TablaFacturas.Filter.FilterText;
      mddatos.TC3.Filtered := true;
      mddatos.TC3.open;
      largas := mddatos.tc3.RecordCount > 0;
      if cortas = largas then //si hay cortas y largas
      begin
        opTodas.Enabled := false;
        opActual.Checked := true;
        MessageDlg('Atencin: no puede imprimir facturas Cortas y ' +
            'Largas en el mismo listado. Debe filtrar por facturas Cortas '+
            'o largas para poder imprimir. Se activar slo la opcin de ' +
            'imprimir Actual.', mtWarning, [mbok],0);
      end;
    end;
    1 : begin //diario
      gEtiqueta.Visible := false;
      caption := 'Impresin de Diario...';
    end;
  end;
end;

procedure TformImprimir.BCancelarClick(Sender: TObject);
begin
  close;
end;

procedure TformImprimir.BVistaPreviaClick(Sender: TObject);
begin
  case formmenuprincipal.tag of
    0 : begin //facturacion
      LTipoL2.Caption := txtEtiqueta.Text;
      imprimirFactura (false);
    end;
    1 : begin //diario
      imprimirDiario (false);
    end;
  end;
  close;
end;

procedure TformImprimir.QRBand1BeforePrint(Sender: TQRCustomBand;
  var PrintBand: Boolean);
begin
  LNombreCliente.caption := '';
  LDireccionCliente.Caption := '';
  lCIFClienteL.Caption := '';
  if not varisnull(mddatos.TFacturasCodigoCliente.Value) then
  begin
    mddatos.TClienteL.Close;
    mdDatos.TClienteL.Filtered := false;
    mddatos.TClienteL.Open;
    if mddatos.TClienteL.Locate('Codigo', mddatos.TFacturasCodigoCliente.Value, []) then
    begin
      if not varisnull(mddatos.TClienteLNombre.Value) then
        LNombreCliente.Caption := mddatos.TClienteLNombre.Value;
      if not varisnull(mddatos.TClienteLNombre.Value) then
        LDireccionCliente.Caption := mddatos.TClienteLDireccion.Value;
      lCIFLbL.Caption := leCadINI('Configuracin', 'Etiqueta - CIF', 'C.I.F.');
      lCIFClienteL.Caption := mdDatos.TClienteLNif.AsString;
      if mdDatos.TClienteLNif.AsString = '' then
        lCIFLbL.Enabled := false;
    end;
  end;
end;

procedure TformImprimir.BTituloBeforePrint(Sender: TQRCustomBand;
  var PrintBand: Boolean);
begin
  LNombreClienteC.caption := '';
  LDireccionClienteC.Caption := '';
  lCIFClienteC.Caption := '';
  if not varisnull(mddatos.TFacturasCodigoCliente.Value) then
  begin
    mddatos.TClienteL.Close;
    mdDatos.TClienteL.Filtered := false;
    mddatos.TClienteL.Open;
    if mddatos.TClienteL.Locate('Codigo', mddatos.TFacturasCodigoCliente.Value, []) then
    begin
      if not varisnull(mddatos.TClienteLNombre.Value) then
        LNombreClienteC.Caption := mddatos.TClienteLNombre.Value;
      if not varisnull(mddatos.TClienteLNombre.Value) then
        LDireccionClienteC.Caption := mddatos.TClienteLDireccion.Value;
      lCIFLbC.Caption := leCadINI('Configuracin', 'Etiqueta - CIF', 'C.I.F.');
      lCIFClienteC.Caption := mdDatos.TClienteLNif.AsString;
      if mdDatos.TClienteLNif.AsString = '' then
        lCIFLbC.Enabled := false;
    end;
  end;
end;

procedure TformImprimir.opTodasClick(Sender: TObject);
begin
  if opTodas.Checked then
  begin
    BVistaPrevia.Enabled := false;
    BImprimir.Default := true;
    BVistaPrevia.Default := false;
  end;
end;

procedure TformImprimir.opActualClick(Sender: TObject);
begin
  if opActual.Checked then
  begin
    BVistaPrevia.Enabled := true;
    BVistaPrevia.Default := true;
    BImprimir.Default := false;
  end;
end;

procedure TformImprimir.BImprimirClick(Sender: TObject);
begin
  case formmenuprincipal.tag of
    0 : begin //facturacion
      LTipoL2.Caption := txtEtiqueta.Text;
      imprimirFactura (true);
    end;
    1 : begin //diario
      imprimirDiario (true);
    end;

  end;
  close;
end;

procedure TformImprimir.DetailBand1BeforePrint(Sender: TQRCustomBand;
  var PrintBand: Boolean);
var
  cpPob, etiquetaCIF : string;
begin
  LDescripcion.Lines.Clear;
  if not varisnull(mddatos.TC4.fieldbyname ('Descripcion').Value) then
    LDescripcion.lines.add (mddatos.TC4.fieldbyname ('Descripcion').Value);
  if mdDatos.TCliente.Locate('Codigo', mddatos.TC4.fieldbyname ('CodigoCliente').Value, []) then
  begin
    if not varisnull(mddatos.TClienteNombre.Value) then
      LClienteNombre.Caption := mddatos.TClienteNombre.Value;
    if not varisnull(mddatos.TClienteDireccion.Value) then
      LClienteDomicilio.Caption := mddatos.TClienteDireccion.Value;
    cpPob := '';
    if not varisnull(mddatos.TClienteCP.Value) then
      cpPob := floattostr(mddatos.TClienteCP.Value);
    if not varisnull(mddatos.TClientePoblacion.Value) then
    begin
      if cpPob <> '' then
        cpPob := cpPob + ' ' + mddatos.TClientePoblacion.Value
      else
        cpPob := mddatos.TClientePoblacion.Value;
    end;
    LClientePoblacion.Caption := cpPob;
    if not varisnull(mddatos.TClienteProvincia.Value) then
      LClienteProvincia.Caption := mddatos.TClienteProvincia.Value;
    if not varisnull(mddatos.TClienteNif.Value) then
    begin
      etiquetaCIF := leCadINI('Configuracin', 'Etiqueta - CIF', 'C.I.F.');
      if etiquetaCIF = '' then
        LClienteCIF.Caption := mddatos.TClienteNif.Value
      else
        LClienteCIF.Caption := etiquetaCIF + ' ' + mdDatos.TClienteNif.Value;
    end;
  end;
end;

procedure TformImprimir.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  if mdDatos.TFacturasPresupuesto.AsBoolean = true then
    esCadINI('Configuracin', 'Etiqueta - Presupuestos - Ttulo', txtEtiqueta.Text)
  else
    esCadINI('Configuracin', 'Etiqueta - Facturas - Ttulo', txtEtiqueta.Text);
end;

end.
