unit UnidadSeleccionClienteFacturas;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ActnList, StdCtrls, Buttons, ExtCtrls, db, dxDBTLCl, dxGrClms, dxTL,
  dxDBCtrl, dxDBGrid, dxCntner, dxEditor, dxExEdtr, dxEdLib,DateUtils, dxgridmenus;

type
  TformGenerarFacturas = class(TForm)
    Panel1: TPanel;
    BitBtn1: TBitBtn;
    ActionList1: TActionList;
    actGenerarFacturas: TAction;
    Tabla: TdxDBGrid;
    LDia: TLabel;
    Label2: TLabel;
    txtDia: TdxSpinEdit;
    txtMes: TdxSpinEdit;
    actSeleccionarTodos: TAction;
    actQuitarSeleccion: TAction;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    TablaNombre: TdxDBGridMaskColumn;
    TablaNif: TdxDBGridMaskColumn;
    TablaDireccion: TdxDBGridMaskColumn;
    TablaTelefono: TdxDBGridMaskColumn;
    TablaCP: TdxDBGridMaskColumn;
    TablaPagoBanco: TdxDBGridCheckColumn;
    TablaPoblacion: TdxDBGridMaskColumn;
    TablaProvincia: TdxDBGridMaskColumn;
    TablaBaseImponible: TdxDBGridMaskColumn;
    TablaNota: TdxDBGridCheckColumn;
    TablaObservacion: TdxDBGridMaskColumn;
    TablaCodigo: TdxDBGridMaskColumn;
    procedure actSeleccionarTodosExecute(Sender: TObject);
    procedure actQuitarSeleccionExecute(Sender: TObject);
    procedure actGenerarFacturasExecute(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure TablaMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  formGenerarFacturas: TformGenerarFacturas;

implementation

uses UnidadModuloDatos, UnidadProcedimientos;

{$R *.dfm}

procedure TformGenerarFacturas.actSeleccionarTodosExecute(Sender: TObject);
begin
  tabla.SelectAll;
end;

procedure TformGenerarFacturas.actQuitarSeleccionExecute(Sender: TObject);
begin
  tabla.ClearSelection;
end;

procedure TformGenerarFacturas.actGenerarFacturasExecute(Sender: TObject);
var
  BM : Tbookmarkstr;
  i : integer;
begin
  if txtMes.Text = '' then
  begin
    MessageDlg('Debe introducir un mes.', mtinformation, [mbok],0);
    txtdia.SetFocus;
    exit;
  end;
  if tabla.SelectedCount = 0 then
    MessageDlg ('Debe seleccionar, al menos, un cliente.', mtinformation,[mbok],0)
  else
  begin
    if tag = 0 then //Diario
    begin
      if txtDia.Text = '' then
      begin
        MessageDlg('Debe introducir un da.', mtinformation, [mbok],0);
        txtdia.SetFocus;
        exit;
      end;
      if messagedlg ('Se van a aadir [' + inttostr(tabla.SelectedCount) +
          '] lnea(s) de Diario.' +
          #13 + #13 + '   Pulse Aceptar para continuar.' +
          #13 + '   Pulse Cancelar para anular el proceso.',
          mtConfirmation,[mbcancel,mbok],0) = mrok then
      begin
        screen.cursor := crhourglass;
        bm := mddatos.TClienteL.Bookmark;
        for i := 0 to tabla.SelectedCount - 1 do
        begin
          mddatos.TClienteL.Bookmark := tabla.selectedrows[i];
          mddatos.TDiario.Insert;
          if not varisnull(mddatos.TClienteLCodigo.value) then
            mddatos.TDiarioCodigoCliente.Value := mddatos.TClienteLCodigo.value;
          if not varisnull(mddatos.TClienteLBaseImponible.value) then
            mddatos.TDiarioBASEIMPONIBLE.Value := mddatos.TClienteLBaseImponible.value;
          if txtdia.Text <> '' then
            mddatos.TDiarioDIA.Value := strtoint(txtdia.Text);
          if txtMes.Text <> '' then
            mddatos.TDiarioMES.Value := strtoint(txtMes.Text);
          mddatos.TDiario.Post;
        end;
        close;
      end;
    end;
    if tag = 30 then //Facturas
    begin
      if messagedlg ('Se van a aadir [' + inttostr(tabla.SelectedCount) +
          '] Nota(s) mensual(es).' +
          #13 + #13 + '   Pulse Aceptar para continuar.' +
          #13 + '   Pulse Cancelar para anular el proceso.',
          mtConfirmation,[mbcancel,mbok],0) = mrok then
      begin
        screen.cursor := crhourglass;
        bm := mddatos.TClienteL.Bookmark;
        for i := 0 to tabla.SelectedCount - 1 do
        begin
          mddatos.TClienteL.Bookmark := tabla.selectedrows[i];
          mddatos.TFacturas.Insert;
          if not varisnull(mddatos.TClienteLCodigo.value) then
            mddatos.TFacturasCodigoCliente.Value := mddatos.TClienteLCodigo.value;
          if not varisnull(mddatos.TClienteLCodigo.value) then
            mddatos.TFacturasCodigoCliente.Value := mddatos.TClienteLCodigo.value;
          mdDatos.TFacturasFecha.Value := pFecha(strtoint(txtDia.Text),strtoint(txtmes.Text),yearof(date));
          mdDatos.TFacturasCorta.Value := true;
          mddatos.TFacturasPresupuesto.Value := false;
          mddatos.TFacturas.Post;
          mddatos.TDetalleFacturas.Insert;
          mddatos.TDetalleFacturasCantidad.Value := 1;
          if not varisnull(mddatos.TClienteLBaseImponible.value) then
            mddatos.TDetalleFacturasPrecio.Value := mddatos.TClienteLBaseImponible.value
          else
            mdDatos.TDetalleFacturasPrecio.Value := 0;
          mdDatos.TDetalleFacturasDescripcion.Value := 'Mes de ' + pMes (strtoint(txtmes.Text));
          mddatos.TDetalleFacturas.Post;
        end;
        close;
      end;
    end;
  end;
end;

procedure TformGenerarFacturas.FormShow(Sender: TObject);
begin
  if tag = 0 then //diario
    caption := 'Generacin de Diario...';
  if tag = 30 then //facturas
  begin
//  ldia.visible := false;
//  txtdia.visible := false;
    caption := 'Generacin de Notas mensuales...';
  end;
  mddatos.TClienteL.Open;
end;

procedure TformGenerarFacturas.TablaMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if (Button <> mbRight) or (Shift <> []) then
    Exit;
  TdxDBGridPopupMenuManager.Instance.ShowGridPopupMenu(Sender as TdxDBGrid);
end;

end.
